//+------------------------------------------------------------------+
//|                                    Magnified Profit Loss.mq4     |
//|                                                                  |
//|                                              Copyright  2011    |
//|                                                                  |
//|    Written by Robert Hill aka MrPip                              |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Robert Hill"
#property indicator_chart_window
//----
  
  extern bool     ThisSymbolOnly = false;
  extern color    ProfitColor=Green;
  extern color    LossColor = Red;
  extern color    InactiveColor = Gray;
  extern int      FontSize=32;
  extern string   FontType="Arial Black";
  extern string   note1="Display the price in what corner?";
  extern string   note2="Upper left=0; Upper right=1";
  extern string   note3="Lower left=2; Lower right=3";
  extern int      WhatCorner=1;
  extern int      X_Offset = 10;
  extern int      Y_Offset = 10;
  
//----

int            ProfitY = 0;
string         ProfitLabel;
string ObjectID = "MPL_";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
     DeleteBadLabels();
     DeleteExistingLabels();
     SetupLabels();
     ClearLabels();
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   ClearLabels();
   DeleteExistingLabels();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
     double Profit;
     string strProfit;
     color FontColor;
     
  
   if (ProfitY < Y_Offset)
   {
     SetupLabels();
     ClearLabels();
     DeleteExistingLabels();
     SetupLabels();// Make sure label settings are OK
   }
   
    Profit = GetProfit();
    Profit = NormalizeDouble(Profit, 2);
    strProfit = DoubleToStr(Profit, 2);
  
     

     if (Profit > 0) FontColor=LawnGreen;
     if (Profit < 0) FontColor=Red;
     
     OutputProfit (strProfit, FontColor);
    
//----   
  }

double GetProfit()
{
   int cnt, total;
   double myProfit = 0, oProfit, oCommission;
   
   total=OrdersTotal();
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
     {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if (ThisSymbolOnly)
      {
         if (OrderSymbol() != Symbol()) continue;
      }
      oProfit = OrderProfit();
      oCommission = OrderCommission();
      if(OrderType() == OP_BUY )
      {
        myProfit += oProfit;
        myProfit += oCommission;
      }
      if(OrderType() == OP_SELL )
      {
         myProfit += oProfit;
         myProfit += oCommission;
      }
             
     }
     return (myProfit);
  }

void ClearLabels()
{
   string mComment = " ";
   
   OutputLabelToChart(ProfitLabel, mComment, InactiveColor);
}

void DeleteBadLabels()
{
   int objLabels = ObjectsTotal(OBJ_LABEL);
   string objName;
   
   if (objLabels > 0)
   {
      for (int i = objLabels; i >= 0;i--)
      {
         objName = ObjectName(i);
         if (StringFind(objName,ObjectID, 0) >= 0)
         {
// Found my object, now check for Symbol

           if (StringFind(objName,Symbol(), 0) < 0)
           {
             ObjectDelete(objName);
           }
         }  
      }
   }
}

void DeleteExistingLabels()
{
   int objLabels = ObjectsTotal(OBJ_LABEL);
   string objName;
   
   if (objLabels > 0)
   {
      for (int i = objLabels; i >= 0;i--)
      {
         objName = ObjectName(i);
         if (StringFind(objName,ObjectID, 0) >= 0) { ObjectDelete(objName); continue; }  
      }
   }
}

void SetupLabels()
{
     ProfitY = Y_Offset;
	  ProfitLabel = ObjectID + Symbol() + "_Profit";
}

void OutputLabelToChart(string LabelName, string LabelStr, color LabelColor)
{
   if (IsTesting())
   {
   if (!IsVisualMode()) return;
   }

  	if(ObjectFind(LabelName) != 0)
   {
   ObjectCreate(LabelName, OBJ_LABEL, 0, 0, 0);
	ObjectSet(LabelName, OBJPROP_CORNER, WhatCorner);
	ObjectSet(LabelName, OBJPROP_XDISTANCE, X_Offset);
	ObjectSet(LabelName, OBJPROP_YDISTANCE, ProfitY);
	}
	ObjectSetText(LabelName, LabelStr, FontSize, FontType, LabelColor);
}

void OutputProfit(string mComment, color mColor)
{
   OutputLabelToChart(ProfitLabel, mComment, mColor);
}

//+------------------------------------------------------------------+